<template>
    <div class="todo">
        <div class="title" >Списки заданий</div>

        <todo-form @new-todo-list="addTodo" @find="searchItem" :next="listTodo.length > 0 ? listTodo[listTodo.length-1].id + 1 : 0" />

        <div class="list-items">
            <div v-if="searchResult.length <= 0" class="empty" >К сожалению ничего не найдено :(</div>
            <list-item @delete-task="deleteTodo"  @update-item="update" v-for="(item,index) in searchResult" :key="index" :item="item"  />
        </div>

    </div>
</template>

<script>
    import todoForm from '@/components/todo/todoFormItem'
    import listItem from '@/components/todo/todoItem'

    export default {
        name: "todo-index",
        components: {
            todoForm,
            listItem
        },
        data() {
            return {
                search: '',
                listTodo: []
            }
        },
        methods: {
            addTodo(todo) {
                this.listTodo.push(todo);
                localStorage.list = JSON.stringify(this.listTodo);
            },
            update() {
                console.log('todoIndex');
                console.log(this.listTodo);
                localStorage.list = JSON.stringify(this.listTodo);
            },
            deleteTodo(item) {
                const taskIndex = this.listTodo.indexOf(item);
                this.listTodo.splice(taskIndex, 1);
                localStorage.list = JSON.stringify(this.listTodo);
            },
            searchItem(key) {
                this.search = key;
            }
        },
        computed: {
            searchResult() {
                return this.listTodo.filter((item) => {
                    return item.name.toLowerCase().match(this.search.toLowerCase())
                })
            },
        },
        mounted() {
            if ( localStorage.getItem('list') === null ) {
                localStorage.setItem('list', '[]');
            }
            this.listTodo=JSON.parse(localStorage.getItem('list'));
        }
    }
</script>

<style lang="scss" scoped>

    .title {
        font-size: 21px;
        text-align: center;
        font-weight: 600;
    }
    .list-items {
        width: 800px;
        margin: 0 auto;

        .empty {
            text-align: center;
            font-size: 21px;
            font-style: italic;
            color: #5f5f5f;
        }
    }

</style>